local assets =
{
    Asset("ANIM", "anim/firerang.zip"),
    Asset("ANIM", "anim/swap_firerang.zip"),
		        Asset("ATLAS", "images/inventoryimages/firerang.xml"),
		Asset("IMAGE", "images/inventoryimages/firerang.tex"),
}

local function OnFinished(inst)
    inst.AnimState:PlayAnimation("used")
    inst:ListenForEvent("animover", inst.Remove)
end

local function OnEquip(inst, owner)  
    owner.AnimState:OverrideSymbol("swap_object", "swap_firerang", "swap_boomerang")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
		    owner:AddTag("owner")
end

local function OnDropped(inst)
    inst.AnimState:PlayAnimation("idle")
end

local function OnUnequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end

local function OnThrown(inst, owner, target)
    if target ~= owner then
        inst.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")
    end
    inst.AnimState:PlayAnimation("spin_loop", true)
end

local function OnCaught(inst, catcher)
	local pt = catcher:GetPosition()  
local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, 200)
   for i, v in ipairs(ents) do
   		v:RemoveTag("marked")
end	

    if catcher then
        if catcher.components.inventory then
            if inst.components.equippable and not catcher.components.inventory:GetEquippedItem(inst.components.equippable.equipslot) then
				catcher.components.inventory:Equip(inst)
			else
                catcher.components.inventory:GiveItem(inst)
            end
            catcher:PushEvent("catch")
        end
    end
end

local function ReturnToOwner(inst, owner)



    if owner and not (inst.components.finiteuses and inst.components.finiteuses:GetUses() < 1) then
        owner.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_return")
        inst.components.projectile:Throw(owner, owner)
    end
end



	local bombchance = 0.80
local function OnHit(inst, owner, target)
    if owner == target then
		local pt = owner:GetPosition()  
local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, 200)
   for i, v in ipairs(ents) do
   		v:RemoveTag("marked")
end	
        if owner.components.inventory then
            if inst.components.equippable and not owner.components.inventory:GetEquippedItem(inst.components.equippable.equipslot) then
				owner.components.inventory:Equip(inst)
        else
            owner.components.inventory:GiveItem(inst)
        end
		    if owner ~= nil and owner.components.sanity ~= nil then

    end
        owner:PushEvent("catch")
    end
    else
        ReturnToOwner(inst, owner)
    end
    if target ~= nil and target:IsValid() then
	 if owner == target then

	 else
	 		    target:AddTag("marked")
			target.components.combat:GetAttacked(owner, 32, nil, "shadow") end
				  if math.random() < bombchance then
			local bounces = 1
	
                for k = 1,bounces do
                    local bouncetarget = FindEntity(target, 6, nil, nil, {"NOCLICK", "marked", "owner"}, {"hostile"})
                    if bouncetarget ~= nil and bouncetarget:IsValid() and bouncetarget.components.health and bouncetarget.components.combat ~= nil then
        inst.components.projectile:Throw(owner, bouncetarget) 
		else
        ReturnToOwner(inst, owner) end
		end
		else
        ReturnToOwner(inst, owner)
		end  end
			
			
        local impactfx = SpawnPrefab("impact")
        if impactfx ~= nil then
            local follower = impactfx.entity:AddFollower()
            follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0)
            impactfx:FacePoint(inst.Transform:GetWorldPosition())
        end
    end



local function OnMiss(inst, owner, target)
    if owner == target then
        OnDropped(inst)
    else
        ReturnToOwner(inst, owner)
    end
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
	
	    inst.entity:AddSoundEmitter()


    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("boomerang")
    inst.AnimState:SetBuild("firerang")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetRayTestOnBB(true)

    inst:AddTag("projectile")
    inst:AddTag("thrown")



    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(0)
    inst.components.weapon:SetRange(TUNING.BOOMERANG_DISTANCE, TUNING.BOOMERANG_DISTANCE)
    -------

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(400)
    inst.components.finiteuses:SetUses(400)

    inst.components.finiteuses:SetOnFinished(OnFinished)

    inst:AddComponent("inspectable")

    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(15)
    inst.components.projectile:SetCanCatch(true)
    inst.components.projectile:SetOnThrownFn(OnThrown)
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnMiss)
    inst.components.projectile:SetOnCaughtFn(OnCaught)


    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem:SetOnDroppedFn(OnDropped)
    inst.components.inventoryitem.atlasname = "images/inventoryimages/firerang.xml"

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(OnEquip)
    inst.components.equippable:SetOnUnequip(OnUnequip)



    return inst
end

return Prefab("firerang", fn, assets)
